//VAʐMRg[

#include	<avr/io.h>
#include	<avr/pgmspace.h>
#include	"comctrl.h"

enum E_RCV_STATUS
{
	ST_READY,
	ST_GETDATA,
	ST_GETDATA_BIN,
};

static	uint8_t	rcvState;
static	uint8_t	rcvCommand;
static	uint8_t	rcvHiLoFlag, hi4bit, lo4bit;
static	uint8_t	rcvMaxCount, rcvError;

//Mobt@
static	uint8_t	rbuf[TOTAL_BUF_SIZE] = {0};
static	uint8_t	ridx;
uint8_t	*comGetDataBuf() { return rbuf; }	//Mobt@̐擪|C^Ԃ

//Q^'A'𗚂猳̐l0`15ɕϊ
#define	ctoi(c)	((c) - 'A')

//̉4bit̐l0`15ɃQ^'A'𗚂ĕɕϊ
#define itoc(n)	('A' + ((n) & 0x0F))

//USART̎Mobt@NA
void	comUsartRcvBufClear()
{
	uint8_t	dmy;
	while (UCSRA & (1 << RXC)) dmy = UDR;
}

//ʐMݒ
void	comInit()
{
	/*	ATtiny2313	VAʐM
	UCSRB:RXEN = 1:M		UCSRB:TXEN = 1:M
	UCSRB:UCSZ2,UCSRC:UCSZ1,UCSZ0 = 011:f[^8rbg
	UCSRC:UPM1,UPM0 = 00:peBȂ, 10:peB
	UCSRC:USBS = 0:Xgbvrbg1rbg, 1:2rbg	ʐMł͈艻̂2rbgw肷Ƃ悢B
	*/
	UBRRH	= 0;
	UBRRL	= F_CPU / 16 / COMCTRL_BAUD_RATE - 1;
	UCSRB	= (1 << RXEN) | (1 << TXEN) | (0 << UCSZ2);
	UCSRC	= (1 << UPM1) | (0 << UPM0) | (1 << USBS) | (1 << UCSZ1) | (1 << UCSZ0);
	
	comUsartRcvBufClear();
	rcvError = 0;
	rcvState = ST_READY;
}

//ʐMĎ^R}hf[^擾
//߂l
//ER}hM҂̏ԂłCOMCTRL_WAIT_RCVԂB
//ER}hMA
//		f[^M܂łCOMCTRL_WAIT_RCVԂB
//		f[^MAMR}hԂB
//Esȃf[^MȂǃG[COMCTRL_RET_UNKNOWN_CMDԂB
uint8_t	comPolling()
{
	//VAʐMM
	if (!(UCSRA & (1 << RXC))) return COMCTRL_WAIT_RCV;
	
	//G[`FbN
	//Et[~OG[ApeBG[BUDRǂݍݑOɃ`FbNȂ΂ȂȂB
	//Ef[^I[o[B
	rcvError = rcvError || (UCSRA & ((1 << FE) | (1 << UPE) | (1 << DOR)));
	
	//Mf[^o
	uint8_t	byteData = UDR;
	
	switch (rcvState)
	{
	case ST_READY:		//R}hM̑ҋ@
		//R}hM̂ƂāAf[^M̏
		rcvCommand = byteData;
		ridx = 0;
		rcvHiLoFlag = 0;
		rcvState = ST_GETDATA;
		break;	//Msiăf[^Ăj
		
	case ST_GETDATA:	//f[^MiLN^][hj
		//IR[hMꍇif[^Ȃ̃R}hꍇAIR[hĂj
		if (byteData == COMCTRL_END_CODE)
		{
			rcvState = ST_READY;
			return rcvCommand;	//MR}hԂ
		}
		
		//obt@TCY𒴂f[^ʂMꍇiIR[hĂȂ󋵁BM̃~XB܂͒ʐMguj
		if (TOTAL_BUF_SIZE <= ridx)
		{
			rcvState = ST_READY;
			return COMCTRL_RET_UNKNOWN_CMD;		//ߕs\ȃR}h󂯎̂Ƃ
		}
		
		//Lȃf[^󂯎̂Ƃăobt@Ɋi[
		//f[^́A1byte̒lʁ^4bitɕAHƂđĂ
		if (rcvHiLoFlag == 0)
		{
			hi4bit = ctoi(byteData);
			rcvHiLoFlag = 1;
		}
		else
		{
			lo4bit = ctoi(byteData);
			rbuf[ridx++] = (hi4bit << 4) | lo4bit;
			rcvHiLoFlag = 0;
		}
		break;	//Ms
		
	case ST_GETDATA_BIN:	//f[^MioCi][hj
		//f[^̂܂܂̒lŃobt@Ɋi[
		rbuf[ridx++] = byteData;
		
		//w肳ꂽf[^MIꍇ
		//E炩̃G[Ńf[^ȂꍇAM҂Ŗ[vɃn}B
		//	MŃ^CAEgoă_~[f[^𑗂ĂƂĂB
		if (ridx == rcvMaxCount)
		{
			rcvState = ST_READY;	//LN^][hɖ߂
			return rcvError ? COMCTRL_RET_RCVERROR : COMCTRL_LCD_BINDATA;
		}
		break;	//Ms
		
	default:	break;
	}
	
	//f[^M𑱍s
	return COMCTRL_WAIT_RCV;
}

//oCif[^M[hɐ؂ւ
void	comChangeBinDataMode(uint16_t length)
{
	ridx = 0;
	rcvMaxCount = length;
	rcvError = 0;
	rcvState = ST_GETDATA_BIN;
}	

//oCi[f[^MŃG[ɁAēxf[^MłԂɃZbg
void	comErrorReset()
{
	UCSRB &= ~(1 << RXEN);	//MsiMobt@NAAG[tOZbgj
	UCSRB |= (1 << RXEN);	//M
	
	//zXgɃG[liUCSRA̒lj𕶎ƂđMiQ^'A'𗚂lj
	comSendByte(itoc(rcvError >> 4));
	comSendByte(itoc(rcvError));
	
	rcvError = 0;
	rcvState = ST_READY;
}

//Mobt@(byte[0][1][2]...)̎wʒu擾
uint8_t	comGetByte(uint8_t idx)
{
	return rbuf[idx];
}

//Mobt@(byte[0][1][2]...)̎wʒuwordlƂĒl擾
uint16_t	comGetWord(uint8_t idx)
{
	uint16_t hiByte = (uint16_t)comGetByte(idx);
	uint16_t loByte = (uint16_t)comGetByte(idx + 1);
	return (hiByte << 8) | loByte;
}

//USART̑Mobt@1byteށizXg֑Mj
void	comSendByte(uint8_t data)
{
	while (!(UCSRA & (1 << UDRE))) {}	//Mobt@̋󂫑҂
	UDR = data;
}

//WHOR}hɑ΂ԐM
void	comSendMyName()
{
	const char *name = PSTR(COMCTRL_MY_NAME);
	uint8_t	c;
	while ((c = pgm_read_byte(name++)) != '\0') comSendByte(c);
}
